<template>
  <div>
    <div class="titleBox">
      <PageTitle title="社会信息人员建设管理">
        <el-button type="primary" @click="addEdit('add', '')">
          <el-icon style="vertical-align: middle">
            <CirclePlus />
          </el-icon>
          <span style="vertical-align: middle">新增</span>
        </el-button>
      </PageTitle>
    </div>
    <!-- 搜索 -->
    <div ref="searchBox">
      <Search :searchArr="searchConfiger" @submit="onSearch" :key="pageData.keyCount" />
    </div>
    <!-- 表格 -->
    <div class="tabBox">
      <MyTable :tableData="pageData.tableData" :tableColumn="pageData.tableColumn" :tableHeight="pageData.tableHeight"
        :key="pageData.keyCount" :tableConfiger="pageData.tableConfiger" :controlsWidth="pageData.controlsWidth"
        @chooseData="chooseData">
        <template #ryMz="{ row }">
          <DictTag :tag="false" :value="row.ryMz" :options="D_BZ_MZ" />
        </template>
        <!-- 操作 -->
        <template #controls="{ row }">
          <el-link size="small" type="success" @click="addEdit('edit', row)">编辑</el-link>
          <el-link size="small" type="danger" @click="deleteRow(row.id)">删除</el-link>
        </template>
      </MyTable>
      <Pages @changeNo="changeNo" @changeSize="changeSize" :tableHeight="pageData.tableHeight" :pageConfiger="{
        ...pageData.pageConfiger,
        total: pageData.total
      }"></Pages>
    </div>
    <!-- 详情 -->
    <DetailForm v-if="show" @updateDate="getList" ref="detailDiloag"
      :dic="{ D_BZ_WHCD, D_BZ_MZ, D_BZ_XB, D_BZ_ZZMM }" />
  </div>
</template>

<script setup>
import PageTitle from "@/components/aboutTable/PageTitle.vue";
import MyTable from "@/components/aboutTable/MyTable.vue";
import Pages from "@/components/aboutTable/Pages.vue";
import Search from "@/components/aboutTable/Search.vue";
import DetailForm from "./components/addForm.vue";
import { qcckGet, qcckPost, qcckDelete } from "@/api/qcckApi.js";
import { reactive, ref, onMounted, getCurrentInstance, nextTick } from "vue";
import { ElMessage } from "element-plus";
const { proxy } = getCurrentInstance();
const { D_BZ_WHCD, D_BZ_MZ, D_BZ_XB, D_BZ_ZZMM } = proxy.$dict(
  "D_BZ_WHCD",
  "D_BZ_MZ",
  "D_BZ_XB",
  "D_BZ_ZZMM"
); //获取字典数据
const detailDiloag = ref();
const searchBox = ref(); //搜索框
const show = ref(false);
const searchConfiger = ref([
  { label: "姓名", prop: "ryXm", placeholder: "请输入姓名", showType: "input" },
  {
    label: "身份证号",
    prop: "rySfzh",
    placeholder: "请输入身份证号",
    showType: "input"
  }
]);

const pageData = reactive({
  tableData: [],
  keyCount: 0,
  tableConfiger: {
    rowHieght: 61,
    showSelectType: "null",
    loading: false
  },
  total: 0,
  pageConfiger: {
    pageSize: 20,
    pageCurrent: 1
  },
  controlsWidth: 120,
  tableColumn: [
    { label: "姓名", prop: "ryXm" },
    { label: "联系电话", prop: "ryLxdh" },
    { label: "身份证号", prop: "rySfzh" },
    { label: "民族", prop: "ryMz", showSolt: true },
    { label: "居住地址", prop: "jzdDz" }
  ]
});

const queryFrom = ref({});

onMounted(() => {
  getList();
  tabHeightFn();
});

// 搜索
const onSearch = (val) => {
  queryFrom.value = { ...val };
  pageData.pageConfiger.pageCurrent = 1;
  getList();
};

const changeNo = (val) => {
  pageData.pageConfiger.pageCurrent = val;
  getList();
};
const changeSize = (val) => {
  pageData.pageConfiger.pageSize = val;
  getList();
};

// 获取列表
const getList = () => {
  pageData.tableConfiger.loading = true;
  let data = { ...pageData.pageConfiger, ...queryFrom.value };
  qcckGet(data, "/mosty-gsxt/tbGsxtJwry/selectPage")
    .then((res) => {
      pageData.tableData = res.records || [];
      pageData.total = res.total;
      pageData.tableConfiger.loading = false;
    })
    .catch(() => {
      pageData.tableConfiger.loading = false;
    });
};

// 删除
const deleteRow = (id) => {
  proxy
    .$confirm("确定要删除", "警告", { type: "warning" })
    .then(() => {
      qcckDelete({}, "/mosty-gsxt/tbGsxtJwry/" + id).then(() => {
        proxy.$message({ type: "success", message: "删除成功" });
        getList();
      });
    })
    .catch(() => { });
};

// 详情
const addEdit = (type, row) => {
  show.value = true;
  nextTick(() => {
    detailDiloag.value.init(type, row);
  });
};

// 表格高度计算
const tabHeightFn = () => {
  pageData.tableHeight =
    window.innerHeight - searchBox.value.offsetHeight - 250;
  window.onresize = function () {
    tabHeightFn();
  };
};
</script>

<style>
.el-loading-mask {
  background: rgba(0, 0, 0, 0.5) !important;
}
</style>
